<template>
  <div>
    <form class="form">
      <label for="brand">Brand </label>
      <input id="brand" type="text" v-model="phone.brand" required>
      <br /> <br />
      <label for="color">Color </label>
      <input id="color" type="text" v-model="phone.color" required>
      <br /> <br />
      <label for="price">Price </label>
      <input id="price" type="number" v-model="phone.price" required>
      <br /> <br />
      <label for="year">Year </label>
      <input id="year" type="text" v-model="phone.age" required>
      <br /> <br />
      <label for="bluetooth">Bluetooth(yes/no) </label>
      <input id="bluetooth" type="text" v-model="phone.bluetooth" required>
      <br /> <br />
      <label for="port">Port(yes/no) </label>
      <input id="port" type="text" v-model="phone.port" required>
      <br /> <br />
      <label for="img">Img </label>
      <input id="img" type="text" v-model="phone.img" required>
      <br /> <br />
      <button @click="editPhone()">Edit</button>
    </form>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
  name: 'EditPage',

  data() {
    return {
      phone: {},
    }
  },

  computed: {
    ...mapGetters('phones', ['getItemById'])
  },

  methods: {
    ...mapActions('phones', ["updateItem", "loadList"]),

    editPhone() {
      if (this.phone) {
        const itemData = JSON.parse(JSON.stringify(this.phone));
        const itemId = this.phone.id;
        this.updateItem({ itemId, data: itemData })
            .then(() => {
              console.log("yeah");
            })
            .catch((error) => {
              console.error("Error:", error);
            });
        this.$router.push("/catalog");
      }
      else {
        console.error("Phone is not initialized.");
      }
    },
  },

  async created() {
    try {
      await this.loadList();
      const phoneId = this.$route.params.id;

      this.phone = this.getItemById(phoneId);
    }
    catch (error) {
      console.error("Error:", error);
    }
  },

}
</script>

<style lang="scss" scoped>

</style>